Attribute VB_Name = "Modul1"
Option Base 1

Public Type IEEEDouble
      Value As Double
   End Type

Public Type IEEESingle
      Value As Single
   End Type

Public Type IEEEBytesDbl
      Bytes(7) As Byte
   End Type
   
Public Type IEEEBytesSng
      Bytes(3) As Byte
   End Type

Public Function GetDbl(ByVal Bytestring As String) As Double
If Len(Bytestring) <> 8 Then
Err.Raise 513, , "GetDbl(): Lnge des bergebenen Strings <> 8"
Exit Function
End If

      Dim MD As IEEEDouble
      Dim MB As IEEEBytesDbl
      Dim I As Long, J As Long
            
      For I = 8 To 1 Step -1
         MB.Bytes(J) = CByte(Asc(Mid$(Bytestring, I, 1)))
         J = J + 1
      Next
      LSet MD = MB
      GetDbl = MD.Value
End Function
Public Function GetSng(ByVal Bytestring As String) As Double
If Len(Bytestring) <> 4 Then
Err.Raise 514, , "GetSng(): Lnge des bergebenen Strings <> 4"
Exit Function
End If

      Dim MS As IEEESingle
      Dim MB As IEEEBytesSng
      Dim I As Long, J As Long
            
      For I = 4 To 1 Step -1
         MB.Bytes(J) = CByte(Asc(Mid$(Bytestring, I, 1)))
         J = J + 1
      Next
      LSet MS = MB
      GetSng = MS.Value
End Function
Public Function GetSKZ(ByVal SKZString As String) As String
If Len(SKZString) <> 12 Then
Err.Raise 515, , "GetSKZ(): Lnge des bergebenen Strings <> 12"
Exit Function
End If
Dim SKZraw, AKZraw, PKZraw, StKZraw, ADRraw As String
Dim SKZ, AKZ, PKZ, StKZ, ADR As Integer
Dim TempString As String

'String aufteilen
SKZraw = Mid$(SKZString, 3, 2)
AKZraw = Mid$(SKZString, 5, 2)
PKZraw = Mid$(SKZString, 7, 2)
StKZraw = Mid$(SKZString, 9, 2)
ADRraw = Mid$(SKZString, 11, 2)

'Dezimalwerte berechnen
SKZ = GetWord(SKZraw)
AKZ = GetWord(AKZraw)
PKZ = GetWord(PKZraw)
StKZ = GetWord(StKZraw)
ADR = GetWord(ADRraw)
TempString = Format(SKZ, " @@@@@ ")
TempString = TempString & Format(AKZ, "@@@@@ ")
If PKZ >= 10000 Then
TempString = TempString & " MMMM  MMMM "
Else
TempString = TempString & Format(PKZ, "@@@@@ ")
TempString = TempString & Format(StKZ, "@@@@@ ")
End If
If ADR > 0 Then TempString = TempString & Format(ADR, "@@@@@")
GetSKZ = TempString
End Function

Public Function GetWord(ByVal WdString As String) As Integer
If Len(WdString) <> 2 Then
Err.Raise 516, , "GetWord(): Lnge des bergebenen Strings <> 2"
Exit Function
End If
Dim HexStr As String
HexStr = "&H" & VBA.Hex(Asc(Left$(WdString, 1))) & VBA.Hex(Asc(Right$(WdString, 1)))
GetWord = Val(HexStr)
End Function

Sub CNC_Conv()

Dim Lesestring As String
Dim Xstr As String
Dim YStr As String
Dim ZStr As String
Dim Zeilennr As Integer
Dim ZeilenStr As String

'Datei abfragen
Dim dlgOpen As FileDialog
    Set dlgOpen = Application.FileDialog( _
        FileDialogType:=msoFileDialogFilePicker)
    'Dialogfenster anzeigen
    OpenErgebnis = dlgOpen.Show
    'Gewhlten Dateinamen + Pfad auslesen
    If OpenErgebnis = -1 Then
    Dateiname = dlgOpen.SelectedItems(1)
    Else
    Exit Sub
    End If

Lnge = FileLen(Dateiname)
Open Dateiname For Binary As #1
Open Dateiname & ".txt" For Output As #2

'Kopfzeilen ausgeben (1)
Print #2, String(80, "=")
Print #2, ""
Print #2, "                      STEUERDATENLISTE    ZEISS  UMESS"
Print #2, ""

' Header-Daten einlesen:
For x = 1 To 10
Lesestring = Input(48, #1)
If x = 1 Then
WSName = Left$(Lesestring, 30)
WSDateiname = Mid$(Lesestring, 31, 14)
End If
If x = 2 Then WSKommentar = Left$(Lesestring, 30)
If x = 3 Then WSKennung = Left$(Lesestring, 10)
Next x

'Kopfzeilen ausgeben (2)
Print #2, "WS-Kennung: " & WSKennung
Print #2, "Werkstueckname: " & WSName
Print #2, "Kommentar: " & WSKommentar
Print #2, "Dateiname: " & WSDateiname
Print #2, String(80, "=")
Print #2, "    |     X    |     Y    |     Z    |            |     |     |     |     |"
Print #2, " NR |--------------------------------|  Funktion  | SKZ | AKZ | PKZ |StKZ | ADR"
Print #2, "    |            Dialog              |            |     |     |     |     |"
Print #2, " NR |   Nennmass   | o.Tol  | u.Tol  |  Funktion  | SKZ | AKZ | PKZ |StKZ |"
Print #2, " NR |          Bezeichnung           |  Funktion  | SKZ | AKZ | PKZ |StKZ | ADR"
Print #2, String(80, "=")

Zeilennr = 1

Do

ZeilenStr = Format(Zeilennr, "@@@@ ")

Lesestring = Input(48, #1)
Anweisung = Mid$(Lesestring, 25, 12)

Select Case Anweisung

Case "ZW-POS      ", _
     "ANTASTUNG   ", _
     "POSITION ANT", _
     "POSITION ZWP", _
     "SCHRITT ZWP ", _
     "SCHRITT ANT ", _
     " FZ TAS WECH", _
     "LFZ TAS WECH", _
     "ANTASTKORR  ", _
     "SCA-KLEM-MOD", _
     "SCA-ZIELFENS", _
     " FZ SC_MPKT ", _
     " FZ SC_WINK ", _
     "LFZ SC_GESCH", _
     "WS-VERSATZ  ", _
     "LFZ VAST    ", _
     "VAST ABW    ", _
     "VAST KREIS  ", _
     "LFZ V-KREIS "


            Select Case Anweisung 'bei Antast-Kommandos Antastrichtung hinzufgen
            Case "ANTASTUNG   ", _
                 "POSITION ANT", _
                 "SCHRITT ANT "
                 AR = Val(Mid$(GetSKZ(Right$(Lesestring, 12)), 11, 2))
                 If AR > 10 Then VZ = "+"
                 If AR < 10 Then VZ = "-"
                 XYZ = "ZYX XYZ"
                 K = Mid$(XYZ, AR - 6, 1)
                 Anweisung = Left$(Anweisung, 10) & VZ & K
            End Select

    If Mid$(Lesestring, 37, 1) = "@" Then  'Kennzeichen fr parametrisierte Steuerdatenzeile
        'PCM-Terme auslesen:
    Trenn1 = InStr(1, Lesestring, ";")
    Trenn2 = InStr(Trenn1 + 1, Lesestring, ";")
    
    Str1 = Left$(Lesestring, Trenn1 - 1)
    Str2 = Mid$(Lesestring, Trenn1 + 1, Trenn2 - Trenn1 - 1)
    Str3 = RTrim(Mid$(Lesestring, Trenn2 + 1, 24 - Trenn2))
       
    Print #2, ZeilenStr & Format(Str1, "@@@@@@@@@@ ") & Format(Str2, "@@@@@@@@@@ ") & Format(Str3, "@@@@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))
    
    Else

    'Koordinaten auslesen:
    Xstr = Left$(Lesestring, 8)
    YStr = Mid$(Lesestring, 9, 8)
    ZStr = Mid$(Lesestring, 17, 8)

    XKo = Round(GetDbl(Xstr), 3)
    YKo = Round(GetDbl(YStr), 3)
    ZKo = Round(GetDbl(ZStr), 3)

    Print #2, ZeilenStr & Format(Format(XKo, "0.000"), "@@@@@@@@@@ ") & Format(Format(YKo, "0.000"), "@@@@@@@@@@ ") & Format(Format(ZKo, "0.000"), "@@@@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))
    End If

Case "SOLLWERTE SN"

     Str1 = Left$(Lesestring, 2)
     Str2 = Mid$(Lesestring, 3, 10)
     Num1 = GetWord(Mid$(Lesestring, 13, 2))
     Num2 = GetWord(Mid$(Lesestring, 15, 2))
     Num3 = GetWord(Mid$(Lesestring, 17, 2))
     Num4 = GetWord(Mid$(Lesestring, 19, 2))
     Num5 = GetWord(Mid$(Lesestring, 21, 2))
     
     Print #2, ZeilenStr & Str1 & "  " & Str2 & " " & Format(Num1, "@@ ") & Format(Num2, "@@ ") & Format(Num3, "@@@ ") & Format(Num4, "@@@ ") & Format(Num5, "@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "LFZ SOLLW SN"

    Str1 = Left$(Lesestring, 16)
    If Asc(Mid$(Lesestring, 40, 1)) = 1 Then
        Str1 = Trim(Str1)
    Else
        Str1 = "              "
    End If

    OTStr = Mid$(Lesestring, 17, 4)
    UTStr = Mid$(Lesestring, 21, 4)

    OT = Round(GetSng(OTStr), 3)
    UT = Round(GetSng(UTStr), 3)

    Print #2, ZeilenStr & Format(Str1, "@@@@@@@@@@@@@@ ") & Format(Format(OT, "0.00#"), "@@@@@@@& ") & Format(Format(UT, "0.00#"), "@@@@@@@& ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "TAS WECH AUT"

    Ablage = Left$(Lesestring, 2)
    TasNr = GetWord(Mid$(Lesestring, 3, 2))
    Num1 = GetDbl(Mid$(Lesestring, 9, 8))
    Num2 = GetDbl(Mid$(Lesestring, 17, 8))
    
    Print #2, ZeilenStr & Ablage & Format(TasNr, "@@@@@@@@ ") & Format(Format(Num1, "0.000"), "@@@@@@@@@@ ") & Format(Format(Num2, "0.000"), "@@@@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))
       
Case "TAS-KOM-WECH", _
     "HUELL-PFERCH", _
     " FZ PEN-NR  ", _
     "DIN-EBENHEIT", _
     "DIN-REC F/A ", _
     "SOLLW EINP  ", _
     "DIN-POSITION", _
     "DIN-KONZENTR", _
     "DIN-KOAXIAL ", _
     "DIN-LAU RLT ", _
     "DO LOOP     "

    Num1 = GetWord(Mid$(Lesestring, 1, 2))
    Num2 = GetWord(Mid$(Lesestring, 3, 2))
    TasNr = GetWord(Mid$(Lesestring, 5, 2))
    Num3 = GetWord(Mid$(Lesestring, 7, 2))
    
    Print #2, ZeilenStr & Format(Num1, "@@@@@@@ ") & Format(Num2, "@@@@@@@ ") & Format(TasNr, "@@@@@@@ ") & Format(Num3, "@@@@@@@  ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "P_PARAM     ", _
     " FZ P_PARAM ", _
     " FZ F_PARAM ", _
     "LFZ P_PARAM ", _
     "LFZ F_PARAM ", _
     "MESSKRAFT   ", _
     "EINPASS PLOT"
          
     Num1 = GetWord(Left$(Lesestring, 2))
     Num2 = GetWord(Mid$(Lesestring, 3, 2))
     Num3 = GetWord(Mid$(Lesestring, 5, 2))
     char = Mid$(Lesestring, 7, 2)
     Num4 = GetDbl(Mid$(Lesestring, 9, 8))
     Num5 = GetDbl(Mid$(Lesestring, 17, 8))
     
     Print #2, ZeilenStr & Format(Num1, "@@@@@ ") & Format(Num2, "@@@ ") & Format(Num3, "@@@ ") & char & " " & Format(Format(Num4, "0.000"), "@@@@@@@ ") & Format(Format(Num5, "0.000"), "@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))
     
Case "AUSREISSER  ", _
     "FILTER MOD1 ", _
     "FORM-PLOTT  "
             
     Dim Ausgabe As String
     Ausgabe = ""
     
     For x = 1 To 15 Step 2
     Ausgabe = Ausgabe & Format(GetWord(Mid$(Lesestring, x, 2)), "@@@ ")
     Next x
     
     Print #2, ZeilenStr & Ausgabe & " " & Anweisung & GetSKZ(Right$(Lesestring, 12))
     
Case "W-LAGE V DIS", _
     "EXCALL-ADR  ", _
     "RESZAEHL SET", _
     "VAST KONTUR2"

     Num1 = GetWord(Left$(Lesestring, 2))
     Print #2, ZeilenStr & Format(Num1, "@@@@@@@@@@                       ") & Anweisung & GetSKZ(Right$(Lesestring, 12))
     
Case "RUECKR 1 ADR"
     
     ADR = GetWord(Left$(Lesestring, 2))
     JN = Mid$(Lesestring, 3, 2)
     If JN = "$1" Then JN = "JA"
     If JN = "$0" Then JN = "NE"

     Print #2, ZeilenStr & Format(ADR, "@@@@@@  ") & JN & "                       " & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "PROT DEF    "

     Num1 = GetWord(Left$(Lesestring, 2))
     Num2 = GetWord(Mid$(Lesestring, 3, 2))
     Num3 = GetWord(Mid$(Lesestring, 5, 2))
     char = Mid$(Lesestring, 7, 2)
     Num4 = GetDbl(Mid$(Lesestring, 9, 8))
     Num5 = GetDbl(Mid$(Lesestring, 17, 8))

     Print #2, ZeilenStr & Format(Num1, "@@@@@ ") & Format(Num2, "@@@ ") & Format(Num3, "@@@ ") & char & " " & Format(Format(Num4, "0.000"), "@@@@@@@ ") & Format(Format(Num5, "0.000"), "@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "RUECKR WSSYS"

     Num1 = GetWord(Left$(Lesestring, 2))
     Str1 = Mid$(Lesestring, 3, 2)
     
     Print #2, ZeilenStr & Format(Num1, "@@@@@@  ") & Str1 & "                       " & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "TR EBENE    ", _
     "TR EBE 0P+1E", _
     "TR NACHDR WI"
     
     Num1 = GetWord(Left$(Lesestring, 2))
     Num2 = GetDbl(Mid$(Lesestring, 9, 8))
     
     Print #2, ZeilenStr & Format(Num1, "@@@@@@@@@@ ") & Format(Format(Num2, "0.000"), "@@@@@@@@@@ ") & "           " & Anweisung & GetSKZ(Right$(Lesestring, 12))
     
Case "RUECKR M ADR", _
     " FZ M-RUECK ", _
     "LFZ M-RUECK "

     Num1 = GetWord(Left$(Lesestring, 2))
     Num2 = GetWord(Mid$(Lesestring, 3, 2))
     Num3 = GetWord(Mid$(Lesestring, 5, 2))
     Str1 = Mid$(Lesestring, 7, 2)
     If Str1 = "$3" Then Str1 = "EN"
     
     Print #2, ZeilenStr & Format(Num1, "@@@@@@@@@@ ") & Format(Num2, "@@@@@@@@@@ ") & Format(Num3, "@@@@@ ") & Str1 & "   " & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "LFZ F-PLOTT "

     Str1 = Left$(Lesestring, 8)
     Num1 = GetDbl(Mid$(Lesestring, 9, 8))
     Num2 = GetWord(Mid$(Lesestring, 17, 2))
     
     Print #2, ZeilenStr & "  " & Str1 & " " & Format(Format(Num1, "0.000"), "@@@@@@@@@@ ") & Format(Num2, "@@@@@@@@@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "LFZ FILTER1 ", _
     "SCANNING    "

     Num1 = GetDbl(Left$(Lesestring, 8))
     Num2 = GetWord(Mid$(Lesestring, 9, 2))
     Num3 = GetWord(Mid$(Lesestring, 11, 2))
     Num4 = GetWord(Mid$(Lesestring, 13, 2))
     Num5 = GetWord(Mid$(Lesestring, 15, 2))
     Num6 = GetWord(Mid$(Lesestring, 17, 2))
     Num7 = GetWord(Mid$(Lesestring, 19, 2))

     Print #2, ZeilenStr & Format(Format(Num1, "0.000"), "@@@@@@@ ") & Format(Num2, "@@@@ ") & Format(Num3, "@@@@ ") & Format(Num4, "@@@@ ") & Format(Num5, "@@@@ ") & Format(Num6, "@ ") & Format(Num7, "@@ ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "SCANNING MOD"

     Num1 = GetWord(Left$(Lesestring, 2))
     Num2 = GetWord(Mid$(Lesestring, 3, 2))
     Num3 = GetWord(Mid$(Lesestring, 5, 2))
     Num4 = GetWord(Mid$(Lesestring, 7, 2))
     Num5 = GetSng(Mid$(Lesestring, 9, 4))
     Num6 = GetSng(Mid$(Lesestring, 13, 4))
     
     Print #2, ZeilenStr & Format(Num1, "@@ ") & Format(Num2, "@@ ") & Format(Num3, "@@ ") & Format(Num4, "@@ ") & Format(Format(Num5, "0.000"), "@@@@@@@@@ ") & Format(Format(Num6, "0.000"), "@@@@@@@@@  ") & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "TRANS EINPAS", _
     "ROTAT EINPAS", _
     "FILE FERTIG ", _
     "RUECKR FILE ", _
     " FZ RUECKR  ", _
     "LFZ RUECKR  ", _
     "LFZ SOLLWFIL", _
     " FZ ISTWFILE"
     
     Num1 = GetWord(Left$(Lesestring, 2))
     Str1 = Mid$(Lesestring, 3, 14)
     
     Print #2, ZeilenStr & Format(Num1, "@@@ ") & Str1 & "               " & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case "EINPASSPARAM"

     Num1 = GetDbl(Left$(Lesestring, 8))
     
     Print #2, ZeilenStr & Format(Format(Num1, "0.000"), "@@@@@@@@@@") & "                       " & Anweisung & GetSKZ(Right$(Lesestring, 12))

Case Else
     Print #2, ZeilenStr & Replace(Left$(Lesestring, 24), Chr(0), " ") & "         " & Anweisung & GetSKZ(Right$(Lesestring, 12))

End Select

If Seek(1) > Lnge Or Anweisung = "P-ENDE      " Then Exit Do
Zeilennr = Zeilennr + 1
Loop


Close #1
Close #2

End Sub
